package WikiAPI::LinkParser;
############################################################
#
# Parser for listLinks
#
############################################################
use Wiki::HTMLParser;
use vars qw(@ISA $VERSION);
use strict;

@ISA = qw(Wiki::HTMLParser);

$VERSION = 0.01;

sub new{
	my $class  = shift;
	my $parser = Wiki::HTMLParser->new(shift);
	my $j      = shift;
	my $code   = shift || 'utf8';

	$parser->{jcode}  = $j;
	$parser->{_links} = [];
	$parser->{code}   = $code;

	bless($parser,$class);

	return $parser;
}

sub get_links{
	shift->{_links};
}


#==============================================================================
sub end_parse{
	shift;
}
#==============================================================================


#==============================================================================
# URL Anchor
#==============================================================================
sub url_anchor {
	my $self = shift;
	my $url  = shift;
	my $name = shift;
	my $j    = $self->{jcode};
	my $code = $self->{code};

	$name = (defined $name) ?
	    Util::url_encode( $j->set($name,'euc')->$code() ) : $url;

	push @{$self->{_links}}, {
		page => $name,
		type => 'external',
		href => $url,
	};
}
#==============================================================================
# Anchor to Wiki page
#==============================================================================
sub wiki_anchor {
	my $self = shift;
	my $page = shift;
	my $name = shift;
	my $j    = $self->{jcode};
	my $code = $self->{code};

	$name = $page if(!defined($name) || $name eq "");

	if($self->{wiki}->page_exists($page)){
		my $url = 
		 $self->{wiki}->config('script_name') . '?page=' . Util::url_encode($page);
		push @{$self->{_links}}, {
			page => Util::url_encode( $j->set($name,'euc')->$code() ),
			type => 'local',
			href => $url,
		};
	}
}
#==============================================================================


1;
